Attribute VB_Name = "basTestDBF"
Option Compare Database
Option Explicit

Private Sub CreateCopyFoxPro3x()
Const FilePath = "C:\DBF\TablVFP3.dbf"
Const NewFilePath = "C:\DBF\TablVFP3new.dbf"
Dim i As Long, vValue As Variant, strFieldName As String
Dim DBFs As clsDBF
Dim DBFd As clsDBF

    Set DBFs = New clsDBF
 With DBFs
  If Not .OpenFile(FilePath) Then GoTo Finish
  If .RecordCount = 0 Then GoTo Finish
        Set DBFd = New clsDBF
  If Not DBFd.CreateNewFile(NewFilePath, .GetFileType, .GetCharSet) Then
        GoTo Finish
  End If
  For i = 0 To .FieldsCount - 1
        strFieldName = .GetFieldName(i)
'  
    If DBFd.CreateField(strFieldName, .GetFieldTypeForDAO(i), _
                .GetFieldTypeOriginal(i), .GetFieldSize(i), _
                .GetFieldDecPlaces(i), .GetFieldIsBinary(i)) < 0 Then
        GoTo Finish
    End If
  Next i
'  (7.2)   .
  If DBFd.CreateField("MYNUMERIC", , Asc("N"), 10, 2) < 0 Then GoTo Finish
  If DBFd.CreateField("MYFLAG", , Asc("L")) < 0 Then GoTo Finish
  Do Until .NoRecord
        DBFd.AddNew
   For i = 0 To .FieldsCount - 1
        strFieldName = .GetFieldName(i)
        
        vValue = .GetFieldValue(i)
        DBFd.SetFieldValue(strFieldName) = vValue
        vValue = DBFd.GetFieldValue(strFieldName)
Debug.Print strFieldName; Tab; vValue
   Next i

        DBFd.SetFieldValue("MYNUMERIC") = 10.5

Debug.Print "MYNUMERIC"; Tab; DBFd.GetFieldValue("MYNUMERIC")
Debug.Print "MYFLAG"; Tab; DBFd.GetFieldValue("MYFLAG")
        DBFd.Update
Debug.Print
        .MoveNext
  Loop
 End With
 With DBFd
'  .      .
        .AddNew
        .SetFieldValue("ID") = 3
        .SetFieldValue("MYDATETIME") = Now
        .SetFieldValue("MYMEMO", True) = "qqqqq"
        .SetFieldValue("MYMEMO", True) = "wwwww"
        .SetFieldValue("MYMEMO", True) = "eeeee"
        .SetFieldValue("MYMEMO", True) = "rrrrr"
        .Update
'   (,  ) .
        .Delete
 End With
    DBFd.CloseFile
    DBFs.CloseFile

Finish:
    Set DBFd = Nothing
    Set DBFs = Nothing
End Sub

Private Sub ConvertFoxPro3xToDBASEV()
Const FilePath = "C:\DBF\TablVFP3.dbf"
Const NewFilePath = "C:\DBF\TablDBASEnew.dbf"
Dim i As Long, vValue As Variant, strFieldName As String
Dim DBFs As clsDBF
Dim DBFd As clsDBF

    Set DBFs = New clsDBF
 With DBFs
  If Not .OpenFile(FilePath) Then GoTo Finish
  If .RecordCount = 0 Then GoTo Finish
        Set DBFd = New clsDBF
  If Not DBFd.CreateNewFile(NewFilePath, conDBFType_dBASE_IV_V, .GetCharSet) Then
        GoTo Finish
  End If
  For i = 0 To .FieldsCount - 1
        strFieldName = .GetFieldName(i)
    If DBFd.CreateField(strFieldName, .GetFieldTypeForDAO(i), _
        .GetFieldTypeOriginal(i), , , .GetFieldIsBinary(i)) < 0 Then
            GoTo Finish
    End If
  Next i
  Do Until .NoRecord
        DBFd.AddNew
   For i = 0 To .FieldsCount - 1
        strFieldName = .GetFieldName(i)
        DBFd.SetFieldValue(strFieldName) = .GetFieldValue(i)
        vValue = DBFd.GetFieldValue(strFieldName)
Debug.Print strFieldName; Tab; vValue
   Next i
        DBFd.Update
Debug.Print
        .MoveNext
  Loop
 End With
    DBFd.CloseFile
    DBFs.CloseFile

Finish:
    Set DBFd = Nothing
    Set DBFs = Nothing
End Sub

